program gifView;

{ pp 뢮 GIF p  ᯫ.
   ⨢ GIFSLOW Holland}

uses crt,dos;

type

    RasterArray = Array [0..63999] of byte;
    RasterP = ^RasterArray;

var
    Width,      { ⠭  GIF  p p⨭ }
    Height,     {  }
    LeftOfs,    { ᬥ饭   p }
    TopOfs,     { ᬥ饭 p }
    RWidth,     { p pp }
    RHeight,    {  pp }
    ClearCode,  {  ⪨ GIF }
    EOFCode,    {   p樨 GIF }
    OutCount,   { 室 稪  'stack count'}
    MaxCode,    { . 祭  ⥪饣 }
    Code,       { p頥 ReadCode 祭}
    CurCode,    { p pp}
    OldCode,    { p pp}
    InCode,     { p pp}
    FirstFree,  { p ⮩ , ᣥp  GIF }
    FreeCode,   { ᫥騩 ⮩   ⠡}
    GIFPtr,     { 㪠⥫  ᨢ  ⥭ 䠩 }
    RasterPtr,
    XC,YC,      { ⥪騥 p p : X  Y }
    Pindex,     {  ᨢ p }
    ReadMask,   { ᪠ AND  ⥪饣 pp }
    I           { 稪 横 }
    :word;

    GifFile:File of RasterArray;  { 室 䠩 }
    GifStuff:RasterP;   {  䠩 }
    Raster:RasterP;     {⮪ pp }
    Raster2:RasterP;    { ⮪, ᫨ 㦭}
    Regs:Registers;     {pp  pp뢠}

    Byteoffset,         {᫥   ᨢ RASTER }
    Bitoffset           {ᬥ饭  ᫥饣   RASTER }
    :LongInt;


    Interlace,  { True, ᫨ p騩 p }
    NextRaster, { True, ᫨ 䠩   > 64000  }
    ColorMap    { True, ᫨  p }
    :Boolean;

    ch           {㦥}
    :char;

    a,              {㦥}
    Resolution,     { p襭, p   GIF }
    BitsPerPixel,   {   , p   GIF }
    Background,     {  䮭, p   GIF }
    ColorMapSize,   {  p, p   GIF }
    CodeSize,       { p , p   GIF }
    InitCodeSize,   {  p⮢ ,  p }
    FinChar,        { p pp }
    Pass,           { ᯮ  뢮 pp筮 p }
    BitMask,        { ᪠ AND   }
    R,G,B
    :byte;


    {  hash-  pp}
    Prefix: Array [0..4095] of word;
    Suffix: Array [0..4095] of byte;

    { 室 ᨢ pp }
    Outcode:Array [0..1024] of byte;

    { p, p   GIF }
    Red,Green,Blue: array [0..255] of byte;

    { EGA p, ⠭ }
    Palette: Array [0..255] of byte;

    { p   䠩 }
    FileString:String [80];

    var Hour,Min,Sec,DSec:word;
    Time1,Time2:longint;
Const

    MaxCodes: Array [0..9] of Word = (4,8,16,$20,$40,$80,$100,$200,$400,$800);

    CodeMask:Array [1..4] of byte= (1,3,7,15);

    PowersOf2: Array [0..8] of word=(1,2,4,8,16,32,64,128,256);

    Masks: Array [0..9] of Integer = (7,15,$1f,$3f,$7f,$ff,$1ff,$3ff,$7ff,
$fff);

    Rastersize:Word = 64000;

function FixTime:longint;
var Hour,Min,Sec,DSec:word;
begin
GetTime(Hour,Min,Sec,Dsec);
FixTime:=Min*60*100+Sec*100+Dsec;
end;

{  p楤p 墠뢠   pp ᨢ
   뤠 訡  砥 墠⪨  }

Procedure AllocMem (Var P:RasterP);

Var ASize:Longint;

Begin
     ASize:=MaxAvail;
     If ASize<RasterSize then
        Begin
             Textmode (15);
             Writeln ('H筮 ᢮  !');
             Halt;
        End
        Else
        Getmem (P,RasterSize);
End;


{ C뢠   䠩 }

Function Getbyte:Byte;

  Begin
       If GIFPtr=RasterSize then Exit;
       Getbyte:=GIFStuff^[GIFPtr];
       GIFPtr:=Succ(GIFPtr);
  End;

{ C뢠    p⠢    word }

Function Getword:Word;
type Uni=record
     case integer of
     1:(A,B:byte);
     2:(Wo:word);
     end;

Var W:Uni;

Begin
     W.A:=Getbyte;
     W.B:=Getbyte;
     Getword:=W.Wo;
End;



{ C뢠 pp   䠩   64000  }

Procedure ReadRaster;

Var BlockLength:Byte;
    I,IOR:Integer;

Begin
   RasterPtr:=0;
   Repeat
   BlockLength:=Getbyte;
     For I:=0 to Blocklength-1 do
       Begin
         If Gifptr = RasterSize then
            Begin
                 {$I-}
                 Read (GIFFile,GIFStuff^);
                 {$I+}
                 IOR:=IOResult;
                 GIFPtr:=0;
            End;
         If not Nextraster then
                  Raster^[RasterPtr]:=Getbyte else
                         Raster2^[RasterPtr]:=Getbyte;
         RasterPtr:=Succ (RasterPtr);
         If RasterPtr=RasterSize then
         Begin
            NextRaster:=True;
            Rasterptr:=0;
            AllocMem (Raster2);
         End;
       End;
   Until Blocklength=0;
End;


{ 롨p ᫥騩   pp ⮪.   ᮤp
 3  12 , 㯠  8-  . ᯮ
祭 ᬥ饭 BIT.  뢠 ᬥ饭   8 }

Procedure ReadCode;
type Univ=record
     case integer of
     1:(b1,b2:byte;w1:word);
     2:(Wo:longint);
     end;

Var RawCode:LongInt;
    U:Univ;
Begin
     ByteOffset:=BitOffset shr 3;

{  p  24-}
     U.b1:=Raster^[Byteoffset];
     U.B2:=Raster^[Byteoffset+1];
     U.W1:=0;
     If CodeSize>=8 then
          U.W1:=Raster^[Byteoffset+2];
     RawCode:=U.Wo;
{ 塞 p 祭  p㫥
Rawcode:=Raster^[Byteoffset]+(256*Raster^[Byteoffset+1])+
         (65536*Raster[Byteoffset+2])
 pp  訡 !}


     Code:=(RawCode shr (BitOffset mod 8)) and ReadMask;

{ p㥬  p  p ᨢ RASTER }

     If (Nextraster) and (Byteoffset>=63000) then
        Begin
             Move (Raster^[Byteoffset],Raster^[0],RasterSize-Byteoffset);
             Move (Raster2^[0],Raster^[RasterSize-Byteoffset],63000);
             Bitoffset:=Bitoffset mod 8;
             FreeMem (Raster2,RasterSize);
        End;

     BitOffset:=BitOffset+CodeSize;

End;


Procedure AddToPixel (Index:Byte);
Label Exi;

Begin
{     Goto Exi;}
     Regs.AH:=12;
     Regs.AL:=Index;
     Regs.CX:=XC;
     Regs.DX:=YC;
     Intr ($10,Regs); {wrpixl(XC,YC,Index);}

{  X-p,  ᫨ ⨣ , 㢥稢 Y-p}

     XC:=Succ (XC);
     If XC=Width then

{ ᫨  pp筮 p⨭,  YC - ᫥ p. ᫨
 ᫨ pp筠 -  (⨣    p ?)}

        Begin

        XC:=0;
        If not Interlace then YC:=Succ (YC) else
            Begin
               Case Pass of
               0: Begin
                  YC:=YC+8;
                  If YC>=Height then
                  Begin
                     Pass:=Succ(Pass);
                     YC:=4;
                  End;
                  End;
               1: Begin
                  YC:=YC+8;
                  If YC>=Height then
                     Begin
                       Pass:=Succ(Pass);
                       YC:=2;
                     End;
                  End;
               2: Begin
                  YC:=YC+4;
                  If YC>=Height then
                     Begin
                          Pass:=Succ(Pass);
                          YC:=1;
                     End;
                  End;
               3: Begin
                  YC:=YC+2;
                  End;
               End;    {Case}
            End;  {If interlace}
        End;
Exi:
End;

{ ᯮ㥬 㭪 BIOS  ⠭ p EGA.
⮡  p㦠 .BGI pp}

Procedure InitEGA;

Begin


{ ⠭ EGA  p᪨ p }

   Regs.AX:=$0010;
   Intr ($10,Regs);

{ ⠭ p }

   Regs.AX:=$1002;
   Regs.DX:=Ofs (Palette);
   Regs.ES:=Seg (Palette);
   Intr ($10,Regs);
End;


{ 塞 p  GIF 祭 ⥭ᨢ. }

Procedure DetColor (Var PValue:Byte;MapValue:Byte);

Var Local:Byte;

Begin
     PValue:=MapValue div 64;
     If PValue=1 then PValue:=2 else
     If PValue=2 then PValue:=1;
End;

{ 塞 祭 祢 p.}

Procedure ReInitialize;
Begin
     XC:=0;          {X  Y p  p ""}
     YC:=0;
     Pass:=0;        {p  0}
     Bitoffset:=0;   {㪠⥫  砫 pp   ⮪}
     GIFPtr:=0;      {  ⥭ 䠩  0}
End;

{ p塞  p GIF  ⠭ pp GIF
   砫쭮 ﭨ }

Procedure DoClear;

    Begin
      CodeSize:=InitCodeSize;
      MaxCode:=MaxCodes [CodeSize-2];
      FreeCode:=FirstFree;
      ReadMask:=Masks [CodeSize-3];
    End;

Begin    {the main program}

{ 樠p㥬 p }

     ReInitialize;         { 樫  p }
     Nextraster:=False;    { 䫠  64000 }

{ 墠   pp ᨢ     䠩 }

     AllocMem (Raster);
     AllocMem (GIFStuff);

{ p  䠩 }

     Write ('Filename: ');
     Readln (Filestring);

{ p 䠩 }

{$I-}
     Assign (giffile,FileString);
     Reset (giffile);
{$I+}

{ pp  訡 I/O }

     I:=IOResult;
     If I<>0 then
        Begin
             Writeln ('訡 p 䠩 ',FileString,'.    ');
             Readln;
             Exit;
        End;

{ C뢠 GIF 䠩. C뢠 N ⮢}

     Writeln ('C뢠  . . . ');
{$I-}
     Read (GIFFile,GIFStuff^);
{$I+}

{ 뫨 訡 ?  64000k ? }

I:=IOResult;

{ C뢠  䠩 GIF. H稭 pp GIF p }

     FileString:='';
     for i:=1 to 6 do
     Begin
         FileString:=FileString+chr(Getbyte);
     End;
     If FileString<>'GIF87a' then
        Begin
             Writeln ('  GIF 䠩,  訡 ⥭ .');
             Readln;
             Exit;
        End;

{ p塞 pp GIF p }

     RWidth:=Getword;         {p   pp}
     RHeight:=Getword;
     {  㯠   p  }
     B:=Getbyte;
     If B and $80=$80 then Colormap:=True else Colormap:=False;
     Resolution:=B and $70 shr 5 +1;
     BitsPerPixel:=B and 7 +1;
     If BitsPerPixel=1 then I:=2 else I:=1 shl BitsPerPixel;
     Write ('Colors: ',I);
     BitMask:=CodeMask [BitsPerPixel];
     Background:=Getbyte;
     B:=Getbyte;         { p 㫥  0'}

{ 塞 pp p,  ⠥ . 塞
pp  p EGA }

     ColorMapSize:=1 shl BitsPerPixel;
     If Colormap then
     Begin
     For I:=0 to ColorMapSize-1 do
     Begin
         Red [I]:=Getbyte;
         Green [I]:=Getbyte;
         Blue [I]:=Getbyte;
         DetColor (R,Red[I]);
         DetColor (G,Green [I]);
         DetColor (B,Blue [I]);
         Palette [I]:=B and 1+(2*(G and 1))+(4*(R and 1))+(8*(B div 2))+(16*(G
div 2))+(32*(R div 2));
     End;
     Writeln;
     Palette [16]:=Background;
     End;

{  p ⠥ pp p⨭ }

     B:=Getbyte;  {p᪠ ᥯pp}
     Leftofs:=Getword;
     Topofs:=Getword;
     Width:=Getword;
     Writeln (': ',Width);
     Height:=Getword;
     Writeln ('p: ',Height);
     A:=Getbyte;
     If A and $40=$40 then Interlace:=True else Interlace:=False;


{ H稭 뢠 pp . p -pp }

     Codesize:=Getbyte;

{ 塞 ⠭ pp,  pp }

     ClearCode:=PowersOf2 [Codesize];
     EOFCode:=ClearCode+1;
     FirstFree:=ClearCode+2;
     FreeCode:=FirstFree;

{  GIF ᯥ䨪樨 pp    p㣨 祭  뤨p
 䠩. }

     Codesize:=Succ (Codesize);
     InitCodeSize:=Codesize;
     Maxcode:=Maxcodes [Codesize-2];
     ReadMask:=Masks [Codesize-3];

{ C뢠 pp . 뤨p   GIF ᨢ  ᨢ
pp, pp㥬  p   ⮪ long,
    ReadCode}

     Writeln ('ᯠ');
     ReadRaster;

{ ⮢  뢮  ᯫ. GIF    㦥 }

     FreeMem (GIFStuff,RasterSize);
     OutCount:=0;

{ ⠭ EGA}
     Writeln (^G); {  㪮 ᨣ - ⮢ !}
     Time1:=FixTime;
     InitEGA;

{ pp㥬 䠩,   䠩. .}

   Repeat

     {C뢠 ᫥騩   pp ᨢ}

          ReadCode;

          If Code <> EOFCode then
          Begin

     { pp塞,   p ?,  ⠥  }

            If Code = ClearCode then
               Begin
                 DoClear;
                 ReadCode;
                 CurCode:=Code;
                 OldCode:=Code;
                 FinChar:=Code and BitMask;
                 AddToPixel (FinChar);
               End
               Else

     {H,   p,  }

               Begin
                CurCode:=Code;
                InCode:=Code;

     {   p FreeCode,  室  hash-⠡; p
      p ᫥騩 ᨬ}

                If Code>=FreeCode then
                  Begin
                    CurCode:=OldCode;
                    OutCode [OutCount]:=FinChar;
                    OutCount:=Succ (OutCount);
                  End;

     { H 諨  hash-⠡.   p  室 ⮪ }

                If CurCode>BitMask then
                   Repeat
                     OutCode [OutCount]:=Suffix [CurCode];
                     OutCount:=Succ (OutCount);
                     CurCode:=Prefix [CurCode];
                   Until CurCode<=BitMask;

      { ᫥   楯窥  }

               FinChar:=CurCode and BitMask;
               OutCode [OutCount]:=FinChar;
               OutCount:=Succ (OutCount);

     { 뢮  p  pp. 宦  ⥪ LIFO }

               For I:=OutCount-1 downto 0 do
                    AddToPixel (Outcode [I]);

      { ⠭ OutCount p⭮  p }

               OutCount:=0;

      { Cp  ⠡-hash.   室  䠩 }

               Prefix [FreeCode]:=OldCode;
               Suffix [FreeCode]:=FinChar;
               OldCode:=InCode;

     { ⥫  ᫥騩 ᫮  ⠡. ᫨ p
     MaxCode, 㢥稢 pp  <12. C騩   CLEAR}

               FreeCode:=Succ (FreeCode);
               If FreeCode>=MaxCode then
                Begin
                  If CodeSize < 12 then
                  Begin
                     CodeSize:=Succ (CodeSize);
                     MaxCode:=MaxCode*2;
                     ReadMask:=Masks [CodeSize-3];
                  End;
                End;
               End {not Clear};

               If Keypressed then
                  Begin
                       Ch:=Readkey;
                       If Ch=#27 then
                          Begin
                               Textmode (15);
                               Exit;
                          End;
                  End;

            End; {not EOFCode}
       Until Code=EOFCode;
     Time2:=FixTime;

       Writeln (^G); {  㪮 ᨣ - p}

    { C  }
    {
    Ch:=Readkey;
    }
    Textmode (15);                 { p⭮  ⥪⮢ p }
    Close (GifFile);
    Time1:=Time2-Time1;
    writeln('Time :',(Time1/(60*100)):7:2,' min  ', Time1 mod (60*100),' sek');
    FreeMem (Raster,RasterSize);

End.

